var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { NgForm } from '@angular/forms';
var AtGrid = (function () {
    function AtGrid() {
        /**Данные*/
        this.data = [];
        /**Колонки*/
        this.metaData = [];
        /**Количество строк на странице*/
        this.quRowOnPage = 10;
        /**Статический режим*/
        this.staticMode = true;
        /**Текущая страница*/
        this.currentPage = 0;
        /**Выделене какой-то позиции*/
        this.onSelect = new EventEmitter();
        /**Выделене какой-то позиции*/
        this.onLoad = new EventEmitter();
    }
    /**Инит компонента*/
    AtGrid.prototype.ngOnInit = function () {
    };
    /**После загрузки вьюхи*/
    AtGrid.prototype.ngAfterViewChecked = function () {
    };
    /**Выделить строку*/
    AtGrid.prototype.selectRow = function (item) {
    };
    /**Первая страница*/
    AtGrid.prototype.firstPage = function () {
        this.currentPage = 0;
    };
    /**Первая страница*/
    AtGrid.prototype.lastPage = function () {
        this.currentPage = this.getQuPage() - 1;
    };
    /**Первая страница*/
    AtGrid.prototype.nextPage = function () {
        if (this.currentPage < (this.getQuPage() - 1)) {
            this.currentPage++;
        }
        else {
            this.currentPage = this.getQuPage() - 1;
        }
    };
    /**Первая страница*/
    AtGrid.prototype.prevPage = function () {
        if (this.currentPage > 0) {
            this.currentPage--;
        }
        else {
            this.currentPage = 0;
        }
    };
    /**Количество страниц*/
    AtGrid.prototype.getQuPage = function () {
        var result = Math.ceil(this.applyFilter().length / this.quRowOnPage);
        if (result <= 0) {
            result = 1;
        }
        return result;
    };
    /**Номер страницы от 1*/
    AtGrid.prototype.getHumanCurrentPage = function () {
        return this.currentPage + 1;
    };
    AtGrid.prototype.applyFilter = function () {
        var result = [];
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var item = _a[_i];
            var checkFilter = true;
            for (var _b = 0, _c = this.metaData; _b < _c.length; _b++) {
                var column = _c[_b];
                if (column.filterInfo.value !== '') {
                    if (item[column.name] != null && item[column.name].toString().indexOf(column.filterInfo.value) !== -1) {
                    }
                    else {
                        checkFilter = false;
                        break;
                    }
                }
            }
            if (checkFilter) {
                result.push(item);
            }
        }
        return result;
    };
    /**Получить строки для страницы*/
    AtGrid.prototype.getRowForPage = function () {
        var index = 0;
        var result = [];
        for (var _i = 0, _a = this.applyFilter(); _i < _a.length; _i++) {
            var item = _a[_i];
            if (index >= this.currentPage * this.quRowOnPage && index < (this.currentPage + 1) * this.quRowOnPage) {
                result.push(item);
            }
            index++;
        }
        return result;
    };
    /**Фильтр изменен*/
    AtGrid.prototype.filterChanged = function (filter) {
        console.log(filter);
    };
    AtGrid.prototype.mouseOver = function (rowNum) {
        this.rowNumMouseOver = rowNum;
    };
    return AtGrid;
}());
__decorate([
    Input(),
    __metadata("design:type", Array)
], AtGrid.prototype, "data", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], AtGrid.prototype, "metaData", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], AtGrid.prototype, "quRowOnPage", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], AtGrid.prototype, "staticMode", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], AtGrid.prototype, "currentPage", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], AtGrid.prototype, "onSelect", void 0);
__decorate([
    ViewChild('myForm'),
    __metadata("design:type", NgForm)
], AtGrid.prototype, "form", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], AtGrid.prototype, "onLoad", void 0);
AtGrid = __decorate([
    Component({
        moduleId: module.id,
        selector: 'at-grid',
        styleUrls: ['at-grid.css'],
        templateUrl: 'at-grid.html'
    })
], AtGrid);
export { AtGrid };
//# sourceMappingURL=at-grid.js.map